// Compiled by ClojureScript 1.9.562 {:target :nodejs}
goog.provide('weathergen.ipc');
goog.require('cljs.core');
goog.require('weathergen.encoding');
weathergen.ipc.electron = require("electron");
weathergen.ipc.channel = "weathergen-ipc";
if(typeof weathergen.ipc.on_message !== 'undefined'){
} else {
weathergen.ipc.on_message = (function (){var method_table__24369__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__24370__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__24371__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__24372__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__24373__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"weathergen.ipc","on-message"),((function (method_table__24369__auto__,prefer_table__24370__auto__,method_cache__24371__auto__,cached_hierarchy__24372__auto__,hierarchy__24373__auto__){
return (function() { 
var G__30660__delegate = function (type,event,args){
return type;
};
var G__30660 = function (type,event,var_args){
var args = null;
if (arguments.length > 2) {
var G__30661__i = 0, G__30661__a = new Array(arguments.length -  2);
while (G__30661__i < G__30661__a.length) {G__30661__a[G__30661__i] = arguments[G__30661__i + 2]; ++G__30661__i;}
  args = new cljs.core.IndexedSeq(G__30661__a,0,null);
} 
return G__30660__delegate.call(this,type,event,args);};
G__30660.cljs$lang$maxFixedArity = 2;
G__30660.cljs$lang$applyTo = (function (arglist__30662){
var type = cljs.core.first(arglist__30662);
arglist__30662 = cljs.core.next(arglist__30662);
var event = cljs.core.first(arglist__30662);
var args = cljs.core.rest(arglist__30662);
return G__30660__delegate(type,event,args);
});
G__30660.cljs$core$IFn$_invoke$arity$variadic = G__30660__delegate;
return G__30660;
})()
;})(method_table__24369__auto__,prefer_table__24370__auto__,method_cache__24371__auto__,cached_hierarchy__24372__auto__,hierarchy__24373__auto__))
,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__24373__auto__,method_table__24369__auto__,prefer_table__24370__auto__,method_cache__24371__auto__,cached_hierarchy__24372__auto__));
})();
}
/**
 * Sends a message from a renderer process to the main process.
 */
weathergen.ipc.send_to_main = (function weathergen$ipc$send_to_main(var_args){
var args__24566__auto__ = [];
var len__24559__auto___30672 = arguments.length;
var i__24560__auto___30673 = (0);
while(true){
if((i__24560__auto___30673 < len__24559__auto___30672)){
args__24566__auto__.push((arguments[i__24560__auto___30673]));

var G__30674 = (i__24560__auto___30673 + (1));
i__24560__auto___30673 = G__30674;
continue;
} else {
}
break;
}

var argseq__24567__auto__ = ((((1) < args__24566__auto__.length))?(new cljs.core.IndexedSeq(args__24566__auto__.slice((1)),(0),null)):null);
return weathergen.ipc.send_to_main.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__24567__auto__);
});

weathergen.ipc.send_to_main.cljs$core$IFn$_invoke$arity$variadic = (function (type,args){
return cljs.core.apply.call(null,(function (){var G__30671 = weathergen.ipc.electron.ipcRenderer;
return G__30671;
})().send,weathergen.ipc.channel,type,cljs.core.map.call(null,weathergen.encoding.encode,args));
});

weathergen.ipc.send_to_main.cljs$lang$maxFixedArity = (1);

weathergen.ipc.send_to_main.cljs$lang$applyTo = (function (seq30666){
var G__30667 = cljs.core.first.call(null,seq30666);
var seq30666__$1 = cljs.core.next.call(null,seq30666);
return weathergen.ipc.send_to_main.cljs$core$IFn$_invoke$arity$variadic(G__30667,seq30666__$1);
});

/**
 * Sends a message from the main process to a renderer process.
 */
weathergen.ipc.send_to_renderer = (function weathergen$ipc$send_to_renderer(var_args){
var args__24566__auto__ = [];
var len__24559__auto___30692 = arguments.length;
var i__24560__auto___30693 = (0);
while(true){
if((i__24560__auto___30693 < len__24559__auto___30692)){
args__24566__auto__.push((arguments[i__24560__auto___30693]));

var G__30694 = (i__24560__auto___30693 + (1));
i__24560__auto___30693 = G__30694;
continue;
} else {
}
break;
}

var argseq__24567__auto__ = ((((2) < args__24566__auto__.length))?(new cljs.core.IndexedSeq(args__24566__auto__.slice((2)),(0),null)):null);
return weathergen.ipc.send_to_renderer.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__24567__auto__);
});

weathergen.ipc.send_to_renderer.cljs$core$IFn$_invoke$arity$variadic = (function (window,type,args){
var wc = window.webContents;
var send = wc.send;
return send.apply(wc,cljs.core.clj__GT_js.call(null,cljs.core.into.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [weathergen.ipc.channel,type], null),cljs.core.map.call(null,weathergen.encoding.encode,args))));
});

weathergen.ipc.send_to_renderer.cljs$lang$maxFixedArity = (2);

weathergen.ipc.send_to_renderer.cljs$lang$applyTo = (function (seq30687){
var G__30688 = cljs.core.first.call(null,seq30687);
var seq30687__$1 = cljs.core.next.call(null,seq30687);
var G__30689 = cljs.core.first.call(null,seq30687__$1);
var seq30687__$2 = cljs.core.next.call(null,seq30687__$1);
return weathergen.ipc.send_to_renderer.cljs$core$IFn$_invoke$arity$variadic(G__30688,G__30689,seq30687__$2);
});

weathergen.ipc.ipc = ((cljs.core._EQ_.call(null,"renderer",process.type))?weathergen.ipc.electron.ipcRenderer:weathergen.ipc.electron.ipcMain);
weathergen.ipc.ipc.on(weathergen.ipc.channel,(function() { 
var G__30705__delegate = function (event,p__30701){
var vec__30702 = p__30701;
var seq__30703 = cljs.core.seq.call(null,vec__30702);
var first__30704 = cljs.core.first.call(null,seq__30703);
var seq__30703__$1 = cljs.core.next.call(null,seq__30703);
var type = first__30704;
var args = seq__30703__$1;
return cljs.core.apply.call(null,weathergen.ipc.on_message,type,event,cljs.core.map.call(null,weathergen.encoding.decode,args));
};
var G__30705 = function (event,var_args){
var p__30701 = null;
if (arguments.length > 1) {
var G__30706__i = 0, G__30706__a = new Array(arguments.length -  1);
while (G__30706__i < G__30706__a.length) {G__30706__a[G__30706__i] = arguments[G__30706__i + 1]; ++G__30706__i;}
  p__30701 = new cljs.core.IndexedSeq(G__30706__a,0,null);
} 
return G__30705__delegate.call(this,event,p__30701);};
G__30705.cljs$lang$maxFixedArity = 1;
G__30705.cljs$lang$applyTo = (function (arglist__30713){
var event = cljs.core.first(arglist__30713);
var p__30701 = cljs.core.rest(arglist__30713);
return G__30705__delegate(event,p__30701);
});
G__30705.cljs$core$IFn$_invoke$arity$variadic = G__30705__delegate;
return G__30705;
})()
);
